#pragma semicolon 1

#include <sourcemod>
#include <knife_arena>
#include <sdktools_functions>
#include <sdktools_gamerules>

public Plugin:myinfo = 
{
	name	= "1vs1 menu",
	author	= "wS",
	version = "1.0.4"
};

#define BUTTON_YES_DEF 3
#define BUTTON_NO_DEF  8

new Handle:g_hTimer = INVALID_HANDLE;
new bool:g_bArenaCreated;
new bool:g_bQuestion;
new g_TT, g_CT;
new bool:g_bTTanswer, bool:g_bCTanswer;
new Handle:g_hCvar_1vs1_question_sec, Float:g_fSec;
new bool:g_bCSGO;
new bool:g_bC4Planted;
new bool:g_bOtkaz;

new BUTTON_YES = BUTTON_YES_DEF;
new BUTTON_NO  = BUTTON_NO_DEF;

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	MarkNativeAsOptional("GameRules_GetProp");
	return APLRes_Success;
}

public OnPluginStart()
{
	g_bCSGO						= GetEngineVersion()	== Engine_CSGO;
	LoadTranslations("knife_arena_1vs1.phrases");

	KA_HookEvent(KA_Event:KA_OnArenaSpawnPost,			OnArenaSpawnPost);
	KA_HookEvent(KA_Event:KA_OnLeaveArena,				OnLeaveArena);
	KA_HookEvent(KA_Event:KA_OnArenaTimer,				OnArenaTimer);
	KA_HookEvent(KA_Event:KA_OnPushToQueue,				OnWantToArena);
	KA_HookEvent(KA_Event:KA_OnPushFromQueueToArena,	OnWantToArena);

	HookEvent("player_death",	question,				EventHookMode_PostNoCopy);
	HookEvent("player_team",	question,				EventHookMode_PostNoCopy);
	HookEvent("player_spawn",	kill,					EventHookMode_Post);
		
	HookEvent("round_start",  	RoundStart,				EventHookMode_PostNoCopy);
	HookEvent("round_end",  	RoundEnd,				EventHookMode_PostNoCopy);
	HookEvent("bomb_planted",	bomb_planted,			EventHookMode_PostNoCopy);
	
	//
	g_hCvar_1vs1_question_sec	= CreateConVar("1vs1_question_sec"	, "10", "Players have 'x' seconds to give answer", _, true, 3.0);
	
	new Handle:hCvar			= CreateConVar("1vs1_button_yes"	, "3", "", _, true, 1.0, true, 9.0);
	BUTTON_YES					= GetButton(hCvar, true);
	HookConVarChange(hCvar,		cvar_button_yes);
	
	hCvar						= CreateConVar("1vs1_button_no"		, "8", "", _, true, 1.0, true, 9.0);
	BUTTON_NO					= GetButton(hCvar, false);
	HookConVarChange(hCvar,		cvar_button_no);
	
	AutoExecConfig(true, "1vs1", "knife_arena/modules");
	//
}

public cvar_button_yes(Handle:hCvar, const String:OldValue[], const String:NewValue[]) { BUTTON_YES = GetButton(hCvar, true); }
public cvar_button_no (Handle:hCvar, const String:OldValue[], const String:NewValue[]) { BUTTON_NO  = GetButton(hCvar, false); }

public OnMapStart() { clear(true); }
public RoundStart(Handle:event, const String:name[], bool:silent) { clear(); }
public RoundEnd  (Handle:event, const String:name[], bool:silent) { clear(true); }
public bomb_planted(Handle:event, const String:name[], bool:silent) { g_bC4Planted = true; }
public OnArenaSpawnPost(const Float:center[3], const Float:tt[3], const Float:ct[3]) { g_bArenaCreated = true; }

GetButton(Handle:hCvar, bool:its_yes_button)
{
	new button = 0;
	new max_button = g_bCSGO ? 8 : 9; // panel
	
	decl String:s[24], String:b[2][12];
	GetConVarString(hCvar, s, sizeof(s));
	TrimString(s);
	if (ExplodeString(s, "-", b, sizeof(b), sizeof(b[])) == 2) {
		button = GetRandomInt(StringToInt(b[0]), StringToInt(b[1]));
	}
	else {
		button = StringToInt(s);
	}
	
	if (its_yes_button)
	{
		if (button < 1 || button >= max_button) {
			button = BUTTON_YES_DEF;
		}
	}
	else if (button < 1 || button > max_button || button == BUTTON_YES || button < BUTTON_YES)
	{
		if ((button = BUTTON_NO_DEF) <= BUTTON_YES) {
			button = max_button;
		}
	}
	
	return button;
}

public OnArenaTimer(sec)			// вопрос задан, ответ не получен, но они уже начали бой на арене (wtf), отключаем вопрос
{
	if (g_bQuestion)
	{
		g_bQuestion = false;
		g_bTTanswer = true;
		g_bCTanswer = true;
		clear_timer();
	}
}

public Action:OnLeaveArena(client)	// не даём выходить пока вопрос активен
{
	if (g_bQuestion)
	{
		PrintCenterText(client, "%t", "NotNow");
		return Plugin_Stop;
	}
	return Plugin_Continue;
}

public Action:OnWantToArena(client)	// закрываем вход на арену (вопрос активен или идёт бой или был отказ)
{
	if (g_bQuestion || (answer() && client != g_TT && client != g_CT))
	{
		PrintCenterText(client, "%t", "NotNow");
		return Plugin_Stop;
	}
	return Plugin_Continue;
}

public kill(Handle:event, const String:name[], bool:silent)		// убиваем левых игроков (вопрос активен или идёт бой или был отказ)
{
	if (!g_bOtkaz && (g_bQuestion || answer()) && !warmup())
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		if (client != g_TT && client != g_CT && GetClientTeam(client) > 1) {
			ForcePlayerSuicide(client);
		}
	}
}

public question(Handle:event, const String:name[], bool:silent)	// остались 1 на 1?
{
	if (g_bArenaCreated && !g_bQuestion && !g_bC4Planted && !answer() && !warmup())
	{
		if (g_hTimer != INVALID_HANDLE) { KillTimer(g_hTimer); }
		g_hTimer = CreateTimer(1.0, TIMER_check);
	}
}

public Action:TIMER_check(Handle:timer)
{
	g_hTimer = INVALID_HANDLE;
	decl tt, ct;
	if (!g_bC4Planted && get(tt, ct))
	{
		if (KA_ClientOnArena(tt) && KA_ClientOnArena(ct)) {
			return Plugin_Stop; // Уже оба на арене, в вопросе нет смысла.
		}

		g_TT = tt;
		g_CT = ct;
		g_bQuestion	= true;
		g_bTTanswer	= false;
		g_bCTanswer	= false;
		g_bOtkaz	= false;
		g_fSec		= GetConVarFloat(g_hCvar_1vs1_question_sec);
		g_hTimer	= CreateTimer(0.1, TIMER_question, _, TIMER_REPEAT);
	}
	return Plugin_Stop;
}

public Action:TIMER_question(Handle:timer)
{
	g_fSec -= 0.1;
	if (!g_bQuestion || g_bC4Planted || g_fSec < 0.1 || !ready(g_TT, 2) || !ready(g_CT, 3))
	{
		g_hTimer = INVALID_HANDLE;
		clear(true);
		return Plugin_Stop;
	}
	if (!g_bTTanswer) { wS_Menu(g_TT); }
	if (!g_bCTanswer) { wS_Menu(g_CT); }
	return Plugin_Continue;
}

wS_Menu(client)
{
	new Handle:panel = CreatePanel();
	decl String:text[100];
	FormatEx(text, sizeof(text), "%T\n ", "p_question", client);
	SetPanelTitle(panel, text);
	
	FormatEx(text, sizeof(text), "%T", "p_yes", client);
	SetPanelCurrentKey(panel, BUTTON_YES);
	DrawPanelItem(panel, text);
	
	FormatEx(text, sizeof(text), "%T\n \n%.1f", "p_no", client, g_fSec);
	SetPanelCurrentKey(panel, BUTTON_NO);
	DrawPanelItem(panel, text);
	
	SendPanelToClient(panel, client, PANEL_answer, 1);
	CloseHandle(panel);
}

public PANEL_answer(Handle:panel, MenuAction:action, client, item)
{
	if (action == MenuAction_Select && item <= 9 && g_fSec > 0.0 && g_bQuestion && !g_bC4Planted && (client == g_TT && !g_bTTanswer || client == g_CT && !g_bCTanswer))
	{
		new tt, ct;
		if (!get(tt, ct) || tt != g_TT || ct != g_CT)
		{
			clear(true);
			return;
		}
		if (item == BUTTON_YES)	// согласен
		{
			if (client == g_TT) { g_bTTanswer = true; }
			else { g_bCTanswer = true; }
			
			if (g_bTTanswer && g_bCTanswer)
			{
				g_bQuestion = false;
				clear_timer();
				KA_PushToQueue(g_TT);
				KA_PushToQueue(g_CT);
			}
			
			PrintToChatAll("%t", "yes", client);
		}
		else			// отказ = выкидываем всех с арены и не даём войти
		{
			g_bOtkaz	= true;
			KA_RemoveFromQueue(g_TT);
			KA_RemoveFromArena(g_TT);
			KA_RemoveFromQueue(g_CT);
			KA_RemoveFromArena(g_CT);
			clear(true);
			g_bTTanswer = true;
			g_bCTanswer = true;
			PrintToChatAll("%t", "no",  client);
		}
	}
}

clear(bool:bClearArena = false)
{
	if (bClearArena) { g_bArenaCreated = false; }
	g_bQuestion  = false;
	g_bTTanswer  = false;
	g_bCTanswer  = false;
	g_bC4Planted = false;
	g_TT = -1;
	g_CT = -1;
	clear_timer();
}

clear_timer()
{
	if (g_hTimer != INVALID_HANDLE)
	{
		KillTimer(g_hTimer);
		g_hTimer = INVALID_HANDLE;
	}
}

bool:ready(client, team) { return IsClientInGame(client) && IsPlayerAlive(client) && GetClientTeam(client) == team; }
bool:answer() { return g_bTTanswer && g_bCTanswer; } // true = идёт бой или был отказ
bool:warmup() { return g_bCSGO && GameRules_GetProp("m_bWarmupPeriod"); }

bool:get(&tt, &ct) // 1 t vs 1 ct?
{
	if (!KA_ArenaExistsAndReady())
	{
		g_bArenaCreated = false;
		return false;
	}
	tt = 0; ct = 0;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && IsPlayerAlive(i))
		{
			if (IsFakeClient(i)) { return false; }
			if (GetClientTeam(i) == 2)
			{
				if (tt) { return false; }
				tt = i;
			}
			else
			{
				if (ct) { return false; }
				ct = i;
			}
		}
	}
	return tt && ct;
}